Subject: Re: [nncp-devel] Problems getting NNCP 4.0 to compile

From: Sergey Matveev <[email-masked]>
Date: Wed, 1 May 2019 23:22:45 +0300

Greetings!

*** Shawn K. Quinn [2019-04-30 22:14]:
>First, it should be noted that NNCP 4.0 appears to require at least Go
>1.11 or later. The 1.10 that comes with Ubuntu 18.04 LTS won't cut it
>anymore.

I build it up with Go 1.10 and GOPATH=$(PWD) BUILDMOD= flags and the
following fix: https://git.cypherpunks.ru/cgit.cgi/nncp.git/commit/?id=191a6f4e446c9c4b7c26fd746300bb775462c9bd
However I did not extensively test its workability.

>../../../gopath/src/cypherpunks.ru/nncp/ctx.go:115:17: invalid
>operation: s.Bavail * int64(s.Bsize) (mismatched types uint64 and int64)

I really tested that version on FreeBSD and forget that golang.org/x/sys
results can differ between various systems:

    [...]
    unix/ztypes_linux_amd64.go:1395:        Bavail  uint64
    unix/ztypes_freebsd_amd64.go:114:       Bavail   int64
    [...]

and that Bavail's differs between GNU/Linux and FreeBSD. I forcefully
convert it to int64 and that should fix the problem.

Also I added determining if Go supports modules and choosing of the
right GOPATH/BUILDMOD options when building. That should work on both
Go 1.10 and 1.12 systems.

Thank you very much for your feedback!!! I very appreciate it!

-- 
Sergey Matveev (http://www.stargrave.org/)
OpenPGP: CF60 E89A 5923 1E76 E263  6422 AE1A 8109 E498 57EF